﻿<?php

########################################################################
# Набор API для получения баланса мобильного телефона.
# project : http://www.it2k.ru/projects/mobile-balance-api
# author  : Egor N. Zuskin (zuskin@me.com)
# version : 1.0
########################################################################
#
# Набор функций для получения мобильного баланса
# Пока работает только с МТС и Билайн
#

DEFINE("CACHE_PATH", "/tmp");             # Директория для сохранения данных
DEFINE("COOKIE_FILE_NAME", CACHE_PATH . "/cookie.txt"); # Имя файла для хранения cookie
DEFINE("OPERATOR_AUTO_DETECT", True);                   # Автоматическое определение оператора
DEFINE("AUTO_SAVE_DATA", True);                         # Сохранять ли данные после автоматического определения оператора
DEFINE("BAD_ATTEMPTS_COUNT", 1);                        # Количество неудачных попыток

# счетчик кол-ва попыток
$attempts_count = 0;

# Масив для ручного определения настроек
# Если номер телефона указан в этом массиве, то скрипт пропускает процесс определения
# оператора и региона
$manual_detect = array (
	"phone" => array("url" => "https://www.skylink.ru", "operator" => "skylink"),
	"phone1" => array("url" => "https://ip.mts.ru/SelfCarePda/Security.mvc/LogOn", "operator" => "mts"), # пример записи для мтс Уральский Федеральный Округ
	"phone2" => array("url" => "https://ip.mts.ru/SelfCarePda/Security.mvc/LogOn", "operator" => "mts"), # пример записи для мтс Уральский Федеральный Округ
	"phone3" => array("url" => "https://ip.mts.ru/SELFCAREPDA/Security.mvc/LogOn?returnLink=http://ip.mts.ru/SELFCAREPDA/Home.mvc", "operator" => "mts"), # пример записи для мтс Уральский Федеральный Округ
	"phone4" => array("url" => "https://uslugi.beeline.ru/loginPage.do|https://uslugi.beeline.ru/vip/prepaid/refreshedPrepaidBalance.jsp", "operator" => "beeline"), # пример для билайна всех регионов
	"phone5" => array("url" => "https://uslugi.beeline.ru/loginPage.do|https://uslugi.beeline.ru/vip/prepaid/refreshedPrepaidBalance.jsp", "operator" => "beeline"), # пример для билайна всех регионов
	"phone6" => array("url" => "https://uslugi.beeline.ru/loginPage.do|https://uslugi.beeline.ru/vip/prepaid/refreshedPrepaidBalance.jsp", "operator" => "beeline"), # пример для билайна всех регионов
	"phone7" => array("url" => "https://uslugi.beeline.ru/loginPage.do|https://uslugi.beeline.ru/vip/prepaid/refreshedPrepaidBalance.jsp", "operator" => "beeline"), # пример для билайна всех регионов
	"habrahabr.carma.yozhiks"   => array("url" => "http://yozhiks.habrahabr.ru", "operator" => "habrahabr.carma") # пример для мониторинга кармы на хабре
);

# Масив подерживаемых операторов, пока их двое
# В этом массиве хранятся шаблон ответа от сервера для дальнейшей обработки.
# Знак "|" означает, что на этом месте должно быть число
$operators1 = array(
	"mts"     => array("name" => 'ОАО "Мобильные Телесистемы"', "result" => "<br/>Баланс: <strong>| руб.</strong>"),
	"beeline" => array("name" => 'ОАО "Вымпел-Коммуникации"',   "result" => '<td class="tabred">|&nbsp;')
);

/**
 * Возвращает баланс телефоного номера
 * @param string $phone_num Номер телефона
 * @param string $password Пароль для доступа к личному кабинету
 * @return int
 * Принцеп работы достаточно прост: если константа OPERATOR_AUTO_DETECT = true тогда
 * опредилением оператора и адреса личного кабинета занимается функция "get_phone_info_by_phone_num"
 * иначе настройки берутся из переменной $manual_detect, после этого делается логин в личный кабинет
 * (post запрос), при помощи библиотеки php-curl. Соответственно вывод этого запроса парсится по
 * шаблону указанного отнасительно оператора (переменная $operators, индекс "result")
 */

$balance=get_balance('phone1','password1');
if ($balance <> 999) 
{
exec("wget http://127.0.0.1/objects/?object=andy\&op=m\&m=balanceChanged\&balance=".$balance." -O \/dev\/null");
};
$balance=get_balance('phone2','password2');
if ($balance <> 999) 
{
exec("wget http://127.0.0.1/objects/?object=olga\&op=m\&m=balanceChanged\&balance=".$balance." -O \/dev\/null");
};
$balance=get_balance('phone3','password3');
if ($balance <> 999) 
{
exec("wget http://127.0.0.1/objects/?object=gsmalarm\&op=m\&m=balanceChanged\&balance=".$balance." -O \/dev\/null");
};
$balance=get_balance('phone4','password4');
if ($balance <> 999) 
{
exec("wget http://127.0.0.1/objects/?object=polina\&op=m\&m=balanceChanged\&balance=".$balance." -O \/dev\/null");
};
$balance=get_balance('phone5','password5');
if ($balance <> 999) 
{
exec("wget http://127.0.0.1/objects/?object=gsmtracker\&op=m\&m=balanceChanged\&balance=".$balance." -O \/dev\/null");
};

function get_balance($phone_num, $password)
{
	global $manual_detect, $operators1, $attempts_count;

	$attempts_count ++;

	# Получиаем оператора и url для запроса, отнасително телефоного номера
	$phone_info = isset($manual_detect[$phone_num]) ? $manual_detect[$phone_num] : ((OPERATOR_AUTO_DETECT) ? get_phone_info_by_phone_num($phone_num) : array("url" => "", "operator" => ""));
	//$phone_info = (OPERATOR_AUTO_DETECT) ? get_phone_info_by_phone_num($phone_num) : ((isset($manual_detect[$phone_num])) ? $manual_detect[$phone_num] : array("url" => "", "operator" => ""));
	if ($phone_info['operator'] == "unknown")
	{
		return "0.00";
	}
	if ($phone_info['operator'] == "skylink")
	{
		return shell_exec('/var/www/smarthome/sky.sh '.$phone_num.' '.$password);
	}

	# Данные которые отправляются (POST)
	$post['_stateParam']       = "";
	$post['_forwardName']      = "";
	$post['_expandStatus']     = "";
	$post['ecareAction']       = "login";
	$post['_resetBreadCrumbs'] = "";
	$post['submit'] = "Войти";

	$post['userName'] = $phone_num;
	$post['password'] = $password;

	# Может быть не один запрос, как в примере с билайном
	# сначала авторизация, потом запрос баланса, запросы разделяются
	# знаком "|"
	$urls = explode("|", $phone_info['url']);
	for($i=0;$i<count($urls);$i++)
	{
echo $urls[$i];
		# Делаем POST запрос через функцию curl_post
		$text = ($urls[$i] <> "") ? curl_post($urls[$i], $post) : "";
//echo curl_get($urls[$i], $post);
echo '-'.$text.'-';
	}

	# Вырезаем лишнии табы и переходы на новую строку
	$text = str_replace("\n", "", str_replace("\t", "", $text));

	# Вычелсяем сумму, парсим код вида <td>Баланс</td><td>|</td> где знак "|"
	# соответственно сумма баланса телефона
	$result = explode("|", $operators1[$phone_info['operator']]['result']);
	$pos0 = strpos($text, $result[0]);
	# Если возвращается пустой или не неверный ответ
	if ($pos0 === false)
	{
				return "999.00";
	}
	$pos0 = $pos0 + strlen($result[0]);
	$pos1 = strpos($text, $result[1]);

	# Приводим к нормальному виду
	$value = str_replace(",", ".", substr($text, $pos0, ($pos1 - $pos0)));
//echo $value;
	# Сохраняем кешь
	set_cache_value($phone_num, $value);

	# Возвращаем
	return $value;
}

/**
 * Печатает баланс телефоного номера
 * @param string $phone_num Номер телефона
 * @param string $password Пароль для доступа к личному кабинету
 * Ничего не делает ), просто делает вывод предидущей функции
 */
function print_balance($phone_num, $password)
{
	print get_balance($phone_num, $password);
}

/**
 * Возвращает информацию о телефоном номере
 * @param string $phone_num Номер телефона
 * @return array
 * Возвращает масив данных о номере, точнее оператора и url личного кабинета относительно оператора.
 * Сначала ищет закешированную информацию, имя файла примерно такое /tmp/9218141111.inc, если находит,
 * то инклюдит файл и возвращает масив, если не находит, тогда делает запрос вида (http://www.mtt.ru/info/def/index.wbp?def=921&number=8141111...)
 * к сайту MTT (www.mtt.ru), парсит и получает следующие данные, имя оператора и регион. Далее вычесляется
 * имя индекса в масиве $operators по полному имени оператора, и потом вычесляется url личного кабинета
 * отнасительно региона и имени оператора, возвращает результат масивом.
 */
function get_phone_info_by_phone_num($phone_num)
{
	# обявляем переменную
    $phone_info = array();

    # смотрим, а не существует ли файл с сохраненными настройкми
    if (file_exists(CACHE_PATH . "/" . $phone_num . ".inc"))
    {
    	# если существует инклюдим его и возвращаем переменную
		include(CACHE_PATH . "/" . $phone_num . ".inc");
		return $phone_info;
    }
    else
    {
    	# иначе придется потрудиться ...
    	# пойдем на МТТ (благослови их господи) и узнаем что за оператор и его регион
		$prefix = substr($phone_num, 0, 3);
		$number = substr($phone_num, 3);

		$get['def']      = $prefix;
		$get['number']   = $number;
		$get['date']     = "";
		$get['region']   = "";
		$get['standard'] = "";
		$get['operator'] = "";

		$text = curl_get("http://www.mtt.ru/info/def/index.wbp", $get);
	    $text = str_replace("\n", "", str_replace("\t", "", $text));
		$pos = strpos($text, '<tr class="last">') + 17;

		# что то не тот ответ который ожидалось увидеть
		if ($pos === false)
		{
			return array("url" => "Не верный телефон", "operator" => "unknown");
		}

		# обязательно перекодируем в родную нам кодировку
		$source = explode("</td>", substr($text, ($pos)));
		$name   = iconv("cp1251", "utf-8", trim(substr($source[0], strpos($source[0], ">")+1)));
		$region = iconv("cp1251", "utf-8", trim(substr($source[1], strpos($source[1], ">")+1)));

		# выбираем оператора
		$operator = get_operator_by_name($name);

		# если не билайн и не мтс бреем
		if ($operator == "unknown")
		{
			return array("url" => "Оператор(".$name.") не поддерживается", "operator" => "unknown");
		}

		# получаем url по которому нам нужно будет получить (масло масленное) баланс
		$url = get_url_by_operator_and_region($operator, $region);

		# сохраняем url и оператора в кешь чтоб нам не мучать МТТ
		if ($url <> "" && AUTO_SAVE_DATA)
		{
            $filename = CACHE_PATH . "/" . $phone_num . ".inc";
            $content = "<?php\n\$phone_info['url']='".$url."';\n\$phone_info['operator']='".$operator."';\n?>";
		    if ($handle = fopen($filename, 'a'))
		    {
			    fwrite($handle, $content);
   			    fclose($handle);
		    }
		}

		# возвращаем что получилось
        return array("url" => $url, "operator" => $operator);
	}
}

/**
 * Возвращает индекс оператора
 * @param string $name Имя оператора
 * @return string
 * Ищет оператора по имени в массиве $operators и возвращает его индекс
 * Если не нашол возвращает unknown
 */
function get_operator_by_name($name)
{
$operators1 = array(
	"mts"     => array("name" => 'ОАО "Мобильные Телесистемы"', "result" => "<br/>Баланс: <strong>| руб.</strong>"),
	"beeline" => array("name" => 'ОАО "Вымпел-Коммуникации"',   "result" => '<td class="tabred">|&nbsp;')
);

	$names = array_keys($operators1);

	for($i=0;$i<count($names);$i++)
	{
		if ($operators1[$names[$i]]['name'] == $name)
		{
			return $names[$i];
		}
	}
	return "unknown";
}

/**
 * Возвращает URL для запроса запроса баланса
 * @param string $operator оператор (mts | beeline)
 * @param string $region Регион
 * @return string
 * Нужно для МТС-а т.к. у них для каждого региона свой домен
 * Если не нашол возвращает пустую строку
 */
function get_url_by_operator_and_region($operator, $region)
{
	if ($operator == "beeline")
	{
		return "https://uslugi.beeline.ru/loginPage.do|https://uslugi.beeline.ru/vip/prepaid/refreshedPrepaidBalance.jsp";
	}
	elseif ($operator == "mts")
	{
		$urls['Алтайский край'] = "issa.sib.mts.ru";
		$urls['Амурская область'] = "ihelper.amur.mts.ru";
		$urls['Архангельская область'] = "ihelper.nw.mts.ru";
		$urls['Астраханская область'] = "ihelper.ug.mts.ru";
		$urls['Белгородская область'] = "ihelper.mts.ru";
		$urls['Брянская область'] = "ihelper.mts.ru";
		$urls['Владимирская область'] = "ihelper.mts.ru";
		$urls['Волгоградская область'] = "ihelper.ug.mts.ru";
		$urls['Вологодская область'] = "ihelper.nw.mts.ru";
		$urls['Воронежская область'] = "ihelper.mts.ru";
		$urls['Еврейская АО'] = "ihelper.eao.mts.ru";
		$urls['Забайкальский край'] = "ihelper.chita.mts.ru";
		$urls['Ивановская область'] = "ihelper.mts.ru";
		$urls['Иркутская область'] = "ihelper.irkutsk.mts.ru";
		$urls['Кабардино-Балкарская Республика'] = "ihelper.ug.mts.ru";
		$urls['Калининградская область'] = "ihelper.nw.mts.ru";
		$urls['Калужская область'] = "ihelper.mts.ru";
		$urls['Камчатский край'] = "ihelper.kamchatka.mts.ru";
		$urls['Карачаево-Черкесская Республика'] = "ihelper.ug.mts.ru";
		$urls['Кемеровская область'] = "issa.sib.mts.ru";
		$urls['Кировская область'] = "ihelper.nnov.mts.ru";
		$urls['Костромская область'] = "ihelper.mts.ru";
		$urls['Краснодарский край'] = "ihelper.ug.mts.ru";
		$urls['Красноярский край'] = "issa.sib.mts.ru";
		$urls['Курганская область'] = "ihelper.ural.mts.ru";
		$urls['Курская область'] = "ihelper.mts.ru";
		$urls['Липецкая область'] = "ihelper.mts.ru";
		$urls['Магаданская область'] = "ihelper.magadan.mts.ru";
		$urls['Москва'] = "ihelper.mts.ru";
		$urls['Мурманская область'] = "ihelper.nw.mts.ru";
		$urls['Ненецкий АО'] = "ihelper.nw.mts.ru";
		$urls['Нижегородская область'] = "ihelper.nnov.mts.ru";
		$urls['Новгородская область'] = "ihelper.nw.mts.ru";
		$urls['Новосибирская область'] = "issa.sib.mts.ru";
		$urls['Омская область'] = "issa.sib.mts.ru";
		$urls['Оренбургская область'] = "ihelper.samara.mts.ru";
		$urls['Орловская область'] = "ihelper.mts.ru";
		// Пензенская ???
		$urls['Пермский край'] = "ihelper.ural.mts.ru";
		$urls['Приморский край'] = "ihelper.primorye.mts.ru";
		$urls['Псковская область'] = "ihelper.nw.mts.ru";
		$urls['Республика Адыгея'] = "ihelper.ug.mts.ru";
		$urls['Республика Алтай'] = "issa.sib.mts.ru";
		$urls['Республика Башкортостан'] = "ihelper.samara.mts.ru";
		$urls['Республика Бурятия'] = "ihelper.buryatia.mts.ru";
		$urls['Республика Дагестан'] = "ihelper.ug.mts.ru";
		$urls['Республика Ингушетия'] = "ihelper.ug.mts.ru";
		$urls['Республика Калмыкия'] = "ihelper.ug.mts.ru";
		$urls['Республика Карелия'] = "ihelper.nw.mts.ru";
		$urls['Республика Коми'] = "ihelper.nw.mts.ru";
		$urls['Республика Марий Эл'] = "ihelper.nnov.mts.ru";
		$urls['Республика Мордовия'] = "ihelper.nnov.mts.ru";
		$urls['Республика Саха (Якутия)'] = "ihelper.sakha.mts.ru";
		$urls['Республика Северная Осетия'] = "ihelper.ug.mts.ru";
		//$urls['Таймырский (Долгано-Ненецкий) АО — Дудинка, Норильск'] = "issa.sib.mts.ru";
		$urls['Республика Татарстан'] = "ihelper.nnov.mts.ru";
		$urls['Республика Тыва'] = "issa.sib.mts.ru";
		$urls['Удмуртская Республика'] = "ihelper.nnov.mts.ru";
		$urls['Республика Хакасия'] = "issa.sib.mts.ru";
		$urls['Ростовская область'] = "ihelper.ug.mts.ru";
		$urls['Рязанская область'] = "ihelper.mts.ru";
		$urls['Самарская область'] = "ihelper.samara.mts.ru";
		$urls['Санкт-Петербург'] = "ihelper.nw.mts.ru";
		$urls['Саратовская область'] = "ihelper.samara.mts.ru";
		$urls['Сахалинская область'] = "ihelper.sakh.mts.ru";
		$urls['Свердловская область'] = "ihelper.ural.mts.ru";
		$urls['Смоленская область'] = "ihelper.mts.ru";
		$urls['Ставропольский край'] = "ihelper.ug.mts.ru";
		$urls['Тамбовская область'] = "ihelper.mts.ru";
		$urls['Тверская область'] = "ihelper.mts.ru";
		$urls['Томская область'] = "issa.sib.mts.ru";
		$urls['Тульская область'] = "ihelper.mts.ru";
		$urls['Тюменская область'] = "ihelper.ural.mts.ru";
		$urls['Ульяновская область'] = "ihelper.samara.mts.ru";
		$urls['Хабаровский край'] = "ihelper.khv.mts.ru";
		$urls['Ханты-Мансийский АО'] = "ihelper.ural.mts.ru";
		$urls['Челябинская область'] = "ihelper.ural.mts.ru";
		$urls['Чеченская Республика'] = "ihelper.ug.mts.ru";
		$urls['Чувашская республика'] = "ihelper.nnov.mts.ru";
		$urls['Чукотский АО'] = "ihelper.chukotka.mts.ru";
		$urls['Ямало-Ненецкий АО'] = "ihelper.ural.mts.ru";
		$urls['Ярославская область'] = "ihelper.mts.ru";

		return (isset($urls[$region])) ? "https://" . $urls[$region] . "/SelfCarePda/Security.mvc/LogOn" : "";
	}
	else
	{
		return "";
	}
}

/**
 * Выводит Регион - URL с сайта МТС
 * Бонус функция ))
 */
function get_mts_urls() {

	$handle = fopen("http://static.mts.ru/upload/images/design/js/mts.regions.ru.js", "r");
	if ($handle)
	{
		$contents = '';
		while (!feof($handle)) {
  			$contents .= fread($handle, 8192);
		}
		fclose($handle);
	}

	$data = array();

	$strings = explode("\n", $contents);

	for($i=7;$i<count($strings)-2;$i++)
	{
		if ($strings[$i] <> "")
		{
			$str  = substr($strings[$i], 14);
			$url  = substr($str, 0, strpos($str, ",")-2);
			$str  = substr($str, strpos($str, ",")+9);
			$name = trim(substr($str, 0, strpos($str, "\"")));

			$data[] = array("url" => $url, "name" => $name);
		}
	}

	for($i=0;$i<count($data);$i++)
	{
		$text = curl_get($data[$i]['url'], array());
		$pos0 = strpos($text, "https")+8;
		$pos1 = strpos($text, "/selfcare");

		if ($pos0 > 9)
		{
			$url = substr($text, $pos0, ($pos1-$pos0));
			print "\$urls['" . $data[$i]['name'] . "'] = \"https://" . $url . "/SelfCarePda/Security.mvc/LogOn\";<br>";
		}

	}
}

/**
 * Сохраняет значение в кеш
 * @param string Имя параметра
 * @param string Значение параметра
 * @return string
 * Открывает файл в директории для кеша с именем $name и разширением txt, и записывает в него значение параметра
 */
function set_cache_value($name, $value)
{
    $filename = CACHE_PATH . "/" . $name . ".txt";
    if ($handle = fopen($filename, 'w+'))
    {
	    fwrite($handle, $value);
		fclose($handle);
    }
}

/**
 * Возращает сохраненное значение из кеша
 * @param string Имя параметра
 * @return string
 * Открывает файл в директории для кеша с именем $name и разширением txt, и возвращает его содержание
 */
function get_cache_value($name)
{
	$filename = CACHE_PATH . "/" . $name . ".txt";
	$contents = "";

	if (! file_exists($filename))
	{
		return "";
	}

    if ($handle = fopen($filename, 'r'))
    {
		$contents = fread($handle, filesize($filename));
		fclose($handle);
    }

    return $contents;
}


/* Стандартные функции для работы с curl, взято с php.net*/
/**
 * Send a POST requst using cURL
 * @param string $url to request
 * @param array $post values to send
 * @param array $options for cURL
 * @return string
 */
function curl_post($url, array $post = NULL, array $options = array())
{
$headers = array (
    'Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*;q=0.8',
    'Accept-Language: ru,en-us;q=0.7,en;q=0.3',
    'Accept-Encoding: deflate',
    'Accept-Charset: windows-1251;q=0.7,*;q=0.7',
        'Connection: close'
        );
    $defaults = array(
        CURLOPT_POST => 1,
        CURLOPT_HEADER => 0,
        CURLOPT_URL => $url,
        CURLOPT_FRESH_CONNECT => 1,
        CURLOPT_RETURNTRANSFER => 1,
        CURLOPT_FORBID_REUSE => 1,
        CURLOPT_TIMEOUT => 40,
        CURLOPT_SSL_VERIFYPEER => false,
        CURLOPT_SSL_VERIFYHOST => false,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_VERBOSE => 0,
        CURLOPT_COOKIEFILE => COOKIE_FILE_NAME,
        CURLOPT_COOKIEJAR  => COOKIE_FILE_NAME,
//	CURLOPT_HTTPHEADER => "Accept-Charset: windows-1251;q=0.7,*;q=0.7",
        CURLOPT_USERAGENT => "Mozilla/5.0 (Windows NT 5.1) AppleWebKit/537.1 (KHTML, like Gecko) Chrome/21.0.1180.89 Safari/537.1",
        CURLOPT_POSTFIELDS => http_build_query($post)
    );

    $ch = curl_init();
    curl_setopt_array($ch, ($options + $defaults));
curl_setopt  ($ch,CURLOPT_HTTPHEADER,$headers);
    if( ! $result = curl_exec($ch))
    {
        //trigger_error(curl_error($ch));
        return "";
    }
    curl_close($ch);
    return $result;
}

/**
 * Send a GET requst using cURL
 * @param string $url to request
 * @param array $get values to send
 * @param array $options for cURL
 * @return string
 */
function curl_get($url, array $get = NULL, array $options = array())
{
    $defaults = array(
        CURLOPT_URL => $url. (strpos($url, '?') === FALSE ? '?' : '') . ((count($get)>0) ? http_build_query($get) : ""),
        CURLOPT_HEADER => 0,
        CURLOPT_RETURNTRANSFER => TRUE,
        CURLOPT_TIMEOUT => 4,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_VERBOSE => 0,
        CURLOPT_COOKIEFILE => COOKIE_FILE_NAME,
        CURLOPT_COOKIEJAR  => COOKIE_FILE_NAME
    );

    $ch = curl_init();
    curl_setopt_array($ch, ($options + $defaults));
    if( ! $result = curl_exec($ch))
    {
        //trigger_error(curl_error($ch));
        return "";
    }
    curl_close($ch);
    return $result;
}
function get_track($number,$ordered,$comment)
{
	global $manual_detect, $operators, $attempts_count;

	$attempts_count ++;
$comment = iconv("cp1251", "utf-8", $comment);
//echo $comment;
$resulttable="<table><tr><th colspan=4><center>Tracking number: ".$number." &nbsp;&nbsp;(".$comment.")</center></th></tr>";
// RUSSIAN POST

	$post['BarCode']       = $number;
	$post['PathCur']       = 'rp/servise/ru/home/postuslug/trackingpo';
	$post['PathWeb']       = 'rp/index/ru/home';
	$post['PathPage']       = 'rp/index/ru/home/search';
	$post['cday']       = '24';
	$post['cmonth']       = '09';
	$post['cyear']       = '2012';
	$post['searchsign']       = '1';
$trackingpage=curl_post('http://www.russianpost.ru/resp_engine.aspx?Path=rp/servise/ru/home/postuslug/trackingpo', $post);
//echo $trackingpage;
$pattern = "/(<table class=\"pagetext\">.*?<\/table>)/s";  
preg_match($pattern, $trackingpage, $matches);
$trackingtable=$matches[1];

preg_match_all("/<tr.*?>(.*?)<\/[\s]*tr>/s", $trackingtable, $matches);
 
  $table = array();
 
  foreach($matches[1] as $row_html)
  {
    preg_match_all("/<td.*?>(.*?)<\/[\s]*td>/s", $row_html, $td_matches);
    $row = array();
    for($i=0; $i<count($td_matches[1]); $i++)
    {
      $td = strip_tags(html_entity_decode($td_matches[1][$i]));
      $row[$i] = $td;
    }
 
    if(count($row) > 0)
      $table[] = $row;
  }
    for($i=(count($table)-1); $i>-1; $i--)
{
//!!!!!!!!!!!!!!!!!!!
$aaa = explode(" ",$table[$i][1]);

$resulttable=$resulttable."<tr><td>".$aaa[0]."</td><td>".trim($table[$i][0])."</td><td>".trim($table[$i][4])."</td><td>".trim($table[$i][3])."</td></tr>";
//$resulttable=$resulttable."<tr><td>".$aaa[0]."</td><td>".trim($table[$i][0])."</td><td>".trim($table[$i][4])."</td><td>Россия</td></tr>";
};

// CHINA POST

	$post['itemNo']       = $number;
$trackingpage=curl_get('http://intmail.183.com.cn/item/trace/itemTraceAction.do?itemNo='.$number, array());
$pattern = "/<\/TR><\/TABLE><BR>.*?(<table.*?<\/table>)/s";  
preg_match($pattern, $trackingpage, $matches);

$trackingtable=$matches[1];
preg_match_all("/<tr.*?>(.*?)<\/[\s]*tr>/s", $trackingtable, $matches);
 
  $table = array();
 
  foreach($matches[1] as $row_html)
  {
    preg_match_all("/<td.*?>(.*?)<\/[\s]*td>/s", $row_html, $td_matches);
    $row = array();
    for($i=0; $i<count($td_matches[1]); $i++)
    {
      $td = strip_tags(html_entity_decode($td_matches[1][$i]));
//echo $td;
      $row[$i] = $td;
    }
 
    if(count($row) > 0)
      $table[] = $row;
  }
//  $table = array_unique($table);
    for($i=1; $i<count($table); $i++)
{
$aaa = trim($table[$i][5]);
$aaa=substr($aaa,8,2).'.'.substr($aaa,5,2).'.'.substr($aaa,0,4);
//!!!!!!!!!!!!!!!!!!!
$resulttable=$resulttable."<tr><td>".$aaa."</td><td>".trim($table[$i][2])."</td><td>&nbsp;</td><td>Китай</td></tr>";
//  foreach($table[$i] as $aa)
//  {echo $aa; echo " - "; }
//echo "<br>";
}//for
//print_r ($table);
$resulttable=$resulttable."<tr><td>".$ordered."</td><td>оформление заказа</td><td>&nbsp;</td><td>&nbsp;</td></tr></table>";

$resulttable = iconv("utf-8", "cp1251", $resulttable);
return $resulttable;
};


function fedex_tracking($number,$ordered)
{


$resulttable="<table><tr><th colspan=4><center>Tracking number: ".$number."</center></th></tr>";


    $tracker = new ParcelTracker();
    $parcel = $tracker->getDetails($number);

        if (!$parcel) {
            // Assert false
            echo "";
        } else {
            // Assert true
//            echo "\tPASS $number\n";
//            $successes++;

            // DEBUG
            foreach ($parcel['locations'] as $location) {
$resulttable.="<tr><td>".date("d.m.Y H:i",strtotime($location['time']." + 1 hour"))."</td><td>".$location['status']."</td><td>&nbsp;</td><td>".$location['location']."</td></tr>";
//                print_r($location);
            }                               

//                $resulttable.=$parcel['locations'];
    }

//$resulttable=$resulttable."<tr><td>".$ordered."</td><td>оформление заказа</td><td>&nbsp;</td><td>&nbsp;</td></tr></table>";
$resulttable=$resulttable."</table>";

$resulttable = iconv("utf-8", "cp1251", $resulttable);

return $resulttable;
};

function emspost_tracking($number,$ordered,$comment)
{


//$resulttable="<table><tr><th colspan=4><center>Tracking number: ".$number."</center></th></tr>";
$resulttable="<table><tr><th colspan=4><center>Tracking number: ".$number." &nbsp;&nbsp;(".$comment.")</center></th></tr>";


$data = array("id" => "$number");                                                                    
$data_string = json_encode($data);                                                                                   
 
 $ch = curl_init('http://emspost.ru/tracking.aspx/TrackOne');                                                                      
 curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");                                                                     
 curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);                                                                  
 curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);                                                                      
 curl_setopt($ch, CURLOPT_HTTPHEADER, array(                                                                          
     'Content-Type: application/json',                                                                                
         'Content-Length: ' . strlen($data_string))                                                                       
         );                                                                                                                   
          
          $trackingpage = curl_exec($ch);
echo $trackingpage;
 
$obj = json_decode($trackingpage, true);
foreach(array_reverse($obj[d][Operations]) as $val)
{
$resulttable.="<tr><td>".$val[opDateTime]."</td><td>".$val[opStatus]."</td><td>&nbsp;</td><td>".$val[opAddressDescription]."</td></tr>";
//echo $val[opAddressDescription];
}
//print_r($obj[d][Operations]);
//echo $obj->{'Operations'};

//                print_r($location);

//                $resulttable.=$parcel['locations'];

$resulttable=$resulttable."<tr><td>".$ordered."</td><td>оформление заказа</td><td>&nbsp;</td><td>&nbsp;</td></tr></table>";
//$resulttable=$resulttable."</table>";

$resulttable = iconv("utf-8", "cp1251", $resulttable);

return $resulttable;
};

?>